#ifndef CCHAINEPERSISTANTE_CC
#define CCHAINEPERSISTANTE_CC

#include <sstream>

#include "CChainePersistante.model.h"

namespace persistance {

// ________________________________________________________________________________________
template <class TStrategie>
std::string CChainePersistante<TStrategie>::smvNomClasse = "";

// ________________________________________________________________________________________
template <class TStrategie>
CChainePersistante<TStrategie>::CChainePersistante (const std::string& kprChaine, bool pvPersistant, bool pvAlloue) :
	CPersistant<TStrategie> (pvPersistant, pvAlloue),
	mvChaine (kprChaine) {};

// ________________________________________________________________________________________
template <class TStrategie>
CChainePersistante<TStrategie>::CChainePersistante (std::istream& prFlux) :
	CPersistant<TStrategie> (prFlux) {

	mvChaine = TStrategie::lireChaine (prFlux);
	};

// ________________________________________________________________________________________
template <class TStrategie>
void  CChainePersistante<TStrategie>::ecrire (std::ostream& prFlux) const {

	CPersistant<TStrategie>::ecrire (prFlux);
	TStrategie::ecrireChaine (prFlux, mvChaine);
	};

// ________________________________________________________________________________________
template <class TStrategie>
CBasePersistant* CChainePersistante<TStrategie>::constructeur (std::istream& prFlux) {

	return new CChainePersistante<TStrategie> (prFlux);
	};

// ________________________________________________________________________________________
template <class TStrategie>
void CChainePersistante<TStrategie>::referencer () {

	if (smvNomClasse.length () == 0)
		smvNomClasse = "persistance::CChainePersistante<" + TStrategie::nomStrategie () + ">";
	CBasePersistant::constructeur fnConstructeur = &CChainePersistante<TStrategie>::constructeur;

	::persistance::CPersistant<TStrategie>::referencer (smvNomClasse, fnConstructeur);
	};

};

#endif // CCHAINEPERSISTANTE_CC
